﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Anis.Twitter.Api;
using System.IO;

namespace Anis.Twitter.Client {
    class TwitterRS {
        static void Main(string[] args) {
            Console.Write("ID:");
            string userID = Console.ReadLine();
            Console.Write("Pass:");
            string userPass = readPassword();
            Console.Write("Page:");
            int page = int.Parse(Console.ReadLine());

            Methods tq = new Methods(userID, userPass);

            Status since_id = null;

            try {
                var timeline = from status in tq.GetRepliesStatus(null, null, page)
                               orderby status.Id
                               select status;

                bool newStatus = false;
                foreach(var status in timeline) {
                    Console.ForegroundColor = ConsoleColor.Magenta;
                    Console.Write(status.User.Screen_name.PadRight(10));
                    Console.ForegroundColor = ConsoleColor.Cyan;
                    Console.WriteLine(status.Created_at.ToString() + "\tID:" + status.Id);
                    Console.ForegroundColor = ConsoleColor.White;
                    Console.WriteLine("\t" + status.Text);
                    Console.Title = status.User.Screen_name + ":" + status.Text;
                    newStatus = true;
                    since_id = new Status() { Id = status.Id + 1 };
                }
                if(newStatus) Console.Beep();
            } catch(Exception ex) {
                using(StreamWriter sw = new StreamWriter("./errlog.txt", true, Encoding.GetEncoding("shift-jis"))) {
                    Console.WriteLine("エラー : " + ex.Message);
                    sw.WriteLine(DateTime.Now.ToString());
                    sw.WriteLine("HelpLink:" + ex.HelpLink);
                    sw.WriteLine("Message:" + ex.Message);
                    sw.WriteLine("Source:" + ex.Source);
                    sw.WriteLine("【StackTrace】");
                    sw.WriteLine(ex.StackTrace);
                    sw.WriteLine();
                }
            }
            Console.ReadLine();
        }

        private static string readPassword() {
            ConsoleKeyInfo ci;
            StringBuilder sb = new StringBuilder();
            while(true) {
                ci = Console.ReadKey(true);
                if(ci.Key == ConsoleKey.Backspace || ci.Key == ConsoleKey.Delete) {
                    if(sb.Length == 0) continue;
                    Console.CursorLeft -= 1;
                    Console.Write(' ');
                    if(sb.Length >= 1) {
                        Console.CursorLeft -= 1;
                    }
                    sb.Remove(sb.Length - 1, 1);
                } else if(ci.Key == ConsoleKey.Enter) {
                    break;
                } else {
                    Console.Write('*');
                    sb.Append(ci.KeyChar);
                }
            }
            Console.WriteLine();
            return sb.ToString();
        }
    }
}